/*
    Copyright 2021. Huawei Technologies Co., Ltd. All rights reserved.

    Licensed under the Apache License, Version 2.0 (the "License")
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        https://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
*/
package com.huawei.hms.flutter.wallet.utils.jwe;

/**
 * Common utility class.
 *
 * @author 005932
 * @since 2019-07-29
 */
public abstract class CommonUtil {
    /**
     * Check if a string is null or empty.
     *
     * @param str the string to be checked.
     * @return if the string is null or empty.
     */
    public static boolean isNull(String str) {
        return null == str || "".equals(str.trim());
    }

    /**
     * Check if an object is null.
     *
     * @param object the object to be checked.
     * @return if the object is null.
     */
    public static boolean isNull(Object object) {
        return object == null;
    }

}
